#source("https://bioconductor.org/biocLite.R")
#biocLite("Biostrings")
#library(Biostrings)

GenomeAligment <- function(S1,S2,velikost,vzdalenost=velikost){
  ######################################################
  ####         S1 -> Prni sekvence - ve ktere hladame
  ####         S2 -> Druha sekvence - kterou hledame
  ####   velikost -> delka nejkratsi shody
  #### vzdalenost -> delka nejvesti mezery
  ######################################################   
  
  hodiny <- proc.time()
  X1<-as.numeric(S1)
  vX1<-length(X1)
  X2<-as.numeric(S2)
  X<-c(X1, X2, 0)
  
  ######################################################
  ####               Vypocet SA
  ###################################################### 
  
  xSA<-rep(0,length(X))
  pb <- txtProgressBar(min = 0, max = length(X), style = 3)
  for(i in 1:length(X)){
    setTxtProgressBar(pb, i)
    pos<-which(X == X[i])                         # pozice vsech prvku stejnych, jako hledany
    a<-0
    posI<-which(pos == i)
    posJ<-pos[posI]                               # pozice hledaneho prvku
    pam<-length(pos)                              # pocet vsech prvku stejnych, jako hledany
    
    while(TRUE){
      a<-a+1                                      # posun pozice hledaneho prvku
      nahore<-which(X[pos + a] > X[posJ + a])     # prvky abecedne vyse, nez hledany
      stejne<-which(X[pos + a] == X[posJ + a])    # stejne prvky jako hledany
      dole<-which(X[pos + a] < X[posJ + a])       # prvky abecedne niz, nez hledany
      pam<-pam-length(nahore)                     # odstraneni prvku abecedne vyse nez porovnavany

      if(length(nahore) != 0 & length(dole) != 0){# odstraneni pozic prvku, ktere nejsou stene jako porovnavany
        pos<-pos[-c(nahore,dole)]
      }else if(length(nahore) != 0){
        pos<-pos[-c(nahore)]
      }else if(length(dole) != 0){
        pos<-pos[-c(dole)]
      }
      
      if(length(stejne)==1||length(stejne)==0){   # ukonceni cyklu, pokud uz zadny prvek neni stejny jako hledany
        break()
      }
    }
    xSA[i] <- pam
  }
  close(pb)
  maxprvek <- max(X)                              # abecedne nejvise polozeny prvek
  
  SA<-NULL
  
  for(i in 0:maxprvek){                           # serazeni pozic jednotlivych prvku a tim vytvo?eni cele SA
    poziceprvku <- which(X==i)
    hodnotyXSAprvku <- xSA[poziceprvku]
    poziceserazenychhodnotXSA <- order(hodnotyXSAprvku)
    SA <- c(SA,poziceprvku[poziceserazenychhodnotXSA])
  }

  ######################################################
  ####            Vytvoyeni ISA
  ###################################################### 
  
  ISA<-order(SA)                                  # vytvoreni ISA z SA

  ######################################################
  ####            Vypocet LCP
  ######################################################

  LCP<-rep(-1,length(X)+1)
  l<-0
  pb <- txtProgressBar(min = 0, max = length(X), style = 3)

  for (i in 1:length(X)) {
    setTxtProgressBar(pb, i)
    j<-ISA[i]
    if (j > 1){
      k<-SA[j- 1]
      while (X[k+l] == X[i+l]){                   # hledame delku spolecnych predpon pro jednotlive sufixy
        if(l+k>length(X)||l+i>length(X)){break()}
        l<-l+1
      }
      LCP[j]<-l
      l<-max(l-1,0)
    }
  }
  close(pb)

  ######################################################
  ####            Nalezeni shodnych sekvenci
  ######################################################
  
  body_x <- body_y <- NULL

  for(xa in 1:length(SA)){

    if(LCP[xa] >= (velikost)){                    # hledame takove shody, ktere jsou vetsi nez nami stanoveny prah a zaroven patri rozdelnim sekvencim
      if((SA[xa]>vX1 && SA[xa-1]<=vX1) ||
         (SA[xa]<=vX1 && SA[xa-1]>vX1)){

        if(SA[xa]<=vX1){
          body_x<-c(body_x,SA[xa]:(SA[xa]+LCP[xa]-1))
          body_y<-c(body_y,(SA[xa-1]-vX1):(SA[xa-1]+LCP[xa]-vX1-1))
        }else{
          body_x<-c(body_x,SA[xa-1]:(SA[xa-1]+LCP[xa]-1))
          body_y<-c(body_y,(SA[xa]-vX1):(SA[xa]+LCP[xa]-vX1-1))
        }
      }
    }
  }
print("---------")
  ######################################################
  ####            Uprava bodu
  ######################################################
  
  d<-0
  while(TRUE){
    d<-d+1
    if(d>length(body_x)){break()}
    dupl<-which(body_x==body_x[d] & body_y==body_y[d])
    
    if(length(dupl)>=2){                          # odtranime duplicitni hodnoty nalezenych bodu
      dupl<-dupl[2:length(dupl)]
      body_x<-body_x[-c(dupl)]
      body_y<-body_y[-c(dupl)]
    }
  }
  vystup_x<-vystup_y<-NULL
  evzda<-evzd<-sqrt(body_x^2+body_y^2)            # vypocteme euklidovskou zvdalenost pro detekci zacatku nalezenych shod
  
  while(TRUE){
    a<-which(evzda==evzd[which.min(evzd)])[1]
    evzd<-evzd[-c(which(evzd==evzda[a]))]
    vystup_x<-c(vystup_x,body_x[a])
    vystup_y<-c(vystup_y,body_y[a])
    stopka<-1
    
    while(stopka==1){
      
      for(i in 1:vzdalenost){
        ano<-which(body_x==(body_x[a]+i) & body_y==(body_y[a]+i))
        if(length(ano)){
          a<-ano
          evzd<-evzd[-c(which(evzd==evzda[a]))]
          break()
        }
      }
      if(i==vzdalenost){
        vystup_x<-c(vystup_x,body_x[a])
        vystup_y<-c(vystup_y,body_y[a])
        stopka<-0
      }
    }  
    if(length(evzd)<=0){break()}
  }
  
  ######################################################
  ####            Vykresleni grafu
  ######################################################
  
  print("-v-v-v-v-v-v- Celkovy cas behu programu -v-v-v-v-v-v-")
  print(proc.time() - hodiny)
  print("-^-^-^-^-^-^- Celkovy cas behu programu -^-^-^-^-^-^-")
  
  print("-----------------------------------------------------")
  
  print("-v-v-v-v-v-v-v-v-v-v- Vysledky -v-v-v-v-v-v-v-v-v-v-")
  plot(vystup_x,
		vystup_y,
		type="n",
		xlab = "1. sekvence",
		ylab = "2. sekvence")                           # vytvoreni grafu
  
  bo_x[1:2]<-0
  for(i in seq(from=1,to=length(vystup_x),by=2)){   # vlozeni usecek, ktere odpovidaji shodam, do grafu
    lines(vystup_x[i:(i+1)],vystup_y[i:(i+1)])
    if(bo_x[2]-bo_x[1]<vystup_x[i+1]-vystup_x[i]){  # nalezeni nejlepsi shody
		  bo_x[1]<-vystup_x[i];bo_x[2]<-vystup_x[i+1]
	  }
  }
  
  write.table(c(vystup_x,"y",vystup_y), paste(getwd(),"/body.txt",sep = ''), eol=",",row.names = FALSE)
  
  return(list(vystup_x,vystup_y))
}

########################################################
#######    __      ### Created By ###   _        #######
#######   / /    __ _ __      __ _   _ (_)  ___  #######
#######  / /    / _` |\ \ /\ / /| | | || | / _ \ #######
####### / /___ | (_| | \ V  V / | |_| || ||  __/ #######
####### \____/  \__,_|  \_/\_/   \__,_||_| \___| #######
########################################################
#### 000 #################################### 000 ######
### 00000000 ############################ 00000000 #####
## 000   000000 ### 00000000000000 #### 0000    00 #####
## 00       00000000000000000000000000000       00 #####
## 00         00000000000000000000000000        00 #####
### 00      00000000000000000000000000000      000 #####
### 000    00000000000000000000000000000000   000 ######
#### 000  0000000000000000000000000000000000 0000 ######
##### 000000000000000000000000000000000000000000 #######
###### 0000000000000000000000000000    00000000 ########
###### 00000000       00000000000        000000 ########
###### 0000000         000000000 000      00000 ########
###### 000000      000 000000000 000      00000 ########
####### 00000      000 000000000         00000 #########
####### 000000        00000000000       00000 ##########
######## 0000000     00000    00000000000000 ###########
######### 000000000000000000000000000000000 ####### 0 ##
########### 00000000000 00000000 00000000 ######### 00 #
############## 000000000        000000 ############ 00 #
#################### 0000000000000 ################ 00 #
############################## 000000000000 ####### 00 #
############################# 000000000000000 #### 00 ##
################# 000000000000000000000000000 ### 00 ###
################ 000     000000000000000000000  00 #####
#################### 000000000000000000000000000 #######
################### 0000000000000000000000000 ##########
##################### 000000000000000000000 ############
########################################################
################### http://klouba.eu ###################
########################################################